
void StandOut(on_or_off)
int on_or_off;


/*
 ---------------------------------------------------------------------------
 
   Last revision - 
 	30 March 1984 - GWS
 
 
   NAME
 	StandOut - set or clear terminal stand-out mode
 
   SYNOPSIS
	void StandOut(on_or_off) 
	int on_or_off;
 
   DESCRIPTION
	Uses termcap(3x) routines to set terminal mode. 
 
   SEE ALSO
	termcap(3) 
 
   DIAGNOSTICS
	If the mode doesn't change, it didn't work. 
 
   AUTHOR
 	George W. Sherouse
 	30 March 1984
 
 ---------------------------------------------------------------------------
*/

{
    static called = 0;
    static char so_id[] = "so", se_id[] = "se", so_str[10], se_str[10];
    static char *so_point = so_str, **so_point2 = &so_point;
    static char *se_point = se_str, **se_point2 = &se_point;
    extern char bp[1024];
    int tgetent(), tputs();
    int putchar();

    if (!called)
    {
	tgetstr(so_id, so_point2);
	tgetstr(se_id, se_point2);
	called++;
    }

    if (on_or_off)
    	(void) tputs(so_str, 1, putchar);
    else
    	(void) tputs(se_str, 1, putchar);
    return;
}
